#!/bin/bash
OPTION='-O3 mytimer.c.o pde.f90'
export OMP_NUM_THREADS=1

# compile and run

echo 'Sequntial nonblocking'
ifort $OPTION gs-seq-nobk.f -o gs-seq-nobk >compile.log
gs-seq-nobk

echo 'Sequntial blocking'
ifort $OPTION gs-seq-bk.f -o gs-seq-bk >compile.log
gs-seq-bk

echo 'Sequntial blocking no recovery'
ifort $OPTION gs-seq-bk-norev.f -o gs-seq-bk-norev >compile.log
gs-seq-bk-norev

echo 'Sequntial nonblocking red/black ordering'
ifort $OPTION rbgs-seq-nobk.f -o rbgs-seq-nobk >compile.log
rbgs-seq-nobk

echo 'Sequntial blocking red/black ordering'
ifort $OPTION rbgs-seq-bk.f -o rbgs-seq-bk >compile.log
rbgs-seq-bk



echo 'Sequntial blocking red/black ordering no recovery'
ifort $OPTION rbgs-seq-bk-norev.f -o rbgs-seq-bk-norev >compile.log
rbgs-seq-bk-norev
