C   JACOBI KERNEL IMPLEMENTAION
      PROGRAM JAC
C
      PARAMETER (N=1279, ITMAX=100, EPS = 0.D0)
      REAL*8   A(N,N),B(N,N),TARRAY(2)
      INTEGER  I,J,T
      REAL*8   TMP
C
C   INITIALIZATION 
      CALL INIT(A,N)
C
C   MAJOR COMPUTATION
C     TIME1 = DTIME(TARRAY)
      DO 10 T = 1,ITMAX
	DO 20 J = 2,N-1
	  DO 20 I = 2,N-1
	    B(I,J) = (A(I+1,J)+A(I-1,J)+A(I,J+1)+A(I,J-1))/4
   20   CONTINUE
	TMP = 0.D0
	DO 30 J = 2,N-1
	  DO 30 I = 2,N-1
C	    TMP = TMP + ABS(A(I,J) - B(I,J))
	    A(I,J) = B(I,J)
   30   CONTINUE
	IF (TMP .LT. EPS) THEN
	  GOTO 71
	END IF
   10 CONTINUE
C     TIME2 = DTIME(TARRAY)
C     PRINT 110,TIME2,TARRAY(1),TARRAY(2)
C 110 FORMAT ('TIME ', F8.4,' SECONDS, (',F8.4,' USER, ',F8.4,
C    > ' SYSTEM)')
C
C   OUTPUT
   71 CALL OUTPUT(A,N)
      STOP
      END
C
      SUBROUTINE INIT(A,N)
      INTEGER N
      REAL*8 A(N,N)
      INTEGER I2,I1
C
      DO 100 I2 = 1,N
	DO 100 I1 = 1,N
	  A(I1,I2) = (I1**2-I2*2)
  100 CONTINUE
C
      RETURN
      END
C
      SUBROUTINE OUTPUT(A,N)
      INTEGER N
      REAL*8 A(N,N)
      INTEGER I1
C
C   OUTPUT THE DIAGONAL
C
      DO 110 I1 = 1,N
	PRINT 120, I1, I1, A(I1,I1)
  110 CONTINUE
  120 FORMAT('A(',I4,',',I4,') = ',F8.0)
      RETURN
      END

