      program jac
c
      parameter (n=4000, itmax=1000)
      real*8 a(n,n),c(n,n), f(n,n)
      integer i,j,t,gt, itmaxin
      real*8 resid, error, TIMER_END, alpha
      real*8 gerror
      character argv*10
      real*8 tol, init
c
      tol = init(a,n,f)
      t = iargc()
      if (t .ge. 1) then
        call getarg(1, argv)
        read (argv, '(I10)') itmaxin
      else
        itmaxin = 8
      end if 


      call TIMER_BEGIN()
      t = 1

      gerror = 10 * tol
      error = 10 * tol
      gt = 0
!$omp parallel default(shared) firstprivate(t, error)
     &    private(i, j, resid)
       do while(t .le. itmax .and. error .ge. tol)

        error = 0.D0
!$omp do 
        do 20 j = 2,n-1
        do 20 i = 2,n-1
          c(i,j)=(a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i,j) 
   20   continue
!$omp end do nowait
!$omp do 
        do 30 j = 2,n-1
        do 30 i = 2,n-1
!		  resid = a(i,j) - c(i,j)
          a(i,j) = c(i,j)
!          error = error + resid * resid
   30   continue 
!$omp end do nowait
       
        if (mod(t, itmaxin) .eq. 0 ) then
          ! global condition
!$omp single
          gerror = 0.D0
          gt = itmaxin + gt + 1
!$omp end single nowait
!$omp barrier
!$omp do
        do j = 2,n-1
        do i = 2,n-1
          c(i,j)=(a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i,j) 
        end do
        end do
!$omp end do
!$omp do reduction(+:gerror)
        do j = 2,n-1
        do i = 2,n-1
		  resid = a(i,j) - c(i,j)
          a(i,j) = c(i,j)
          gerror = gerror + resid * resid
        end do
        end do
!$omp end do 
          error = sqrt(gerror)
        else
          error = 10 * tol
        end if
        t = t + 1
!        end if
      end do
!$omp end parallel
      print *, 'Time:', TIMER_END()
	  print *, 'Iteration:', gt
      print *, 'Inner Iteration:', itmaxin
	  call output(a,n,f)
c
      stop
      end
c
