      program jac

      parameter (n=4000, itmax=1000)
      real*8 a(n,n),c(n,n), f(n,n)
      integer i,j,t
      real*8 resid, error, TIMER_END
      real*8 tol, init

      tol = init(a,n,f)
      
      call TIMER_BEGIN()
      
      do 10 t = 1,itmax
        error = 0.D0      

        do 20 j = 2,n-1
        do 20 i = 2,n-1
          c(i,j)=(a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4 - f(i,j) 
   20   continue


        do 30 j = 2,n-1
        do 30 i = 2,n-1
		  resid = a(i,j) - c(i,j)
          a(i,j) = c(i,j)
          error = error + resid * resid
   30   continue 

	  error = sqrt(error)	  
      if (error .le. tol) then 		    
		exit 
      end if
   10 continue

      print *, 'Time:', TIMER_END()
	  print *, 'Iteration:', t
	  call output(a,n,f)

      stop
      end


