#!/bin/bash
OPTION='-O3 mytimer.c.o pde.f90'
export OMP_NUM_THREADS=1

# compile and run

echo 'Sequntial nonblocking'
ifort $OPTION jac-seq-nobk.f -o jac-seq-nobk >compile.log
jac-seq-nobk

echo 'Sequntial blocking'
ifort $OPTION jac-seq-bk.f -o jac-seq-bk >compile.log
jac-seq-bk

echo 'Sequntial blocking no recovery'
ifort $OPTION jac-seq-bk-norev.f -o jac-seq-bk-norev >compile.log
jac-seq-bk-norev
