      program gs
c
      parameter (n=4000, itmax=1000)
      real*8 a(n,n),c(n,n), f(n,n)
      integer i,j,t
      real*8 resid, error, r0, TIMER_END, tmp
      real*8 alpha, dx, dy, stop
      real*8 tol, init
c
      tol = init(a,n,f)

      call TIMER_BEGIN()
      
      do 10 t = 1,itmax
        error = 0.D0      

        do j = 2,n-1
        do  i = 2,n-1
          if (mod(i+j,2).eq.0) then
          a(i,j)=((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4-f(i,j))
          end if
        end do
        end do

        do j = 2,n-1
        do i = 2,n-1
          if (mod(i+j,2).eq.1) then
          a(i,j)=((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4-f(i,j))
          end if
        end do
        end do

        do j = 2, n-1
        do i = 2, n-1
          resid=a(i,j)-((a(i+1,j)+a(i-1,j)+a(i,j+1)+a(i,j-1))/4-f(i,j))
          error=error + resid * resid
        end do
        end do

	  error = sqrt(error)
  !     print *, error	  

      if (error .le. tol) then 		    
		exit 
      end if
   10 continue

      print *, 'Time:', TIMER_END()
	  print *, 'Iteration:', t
	  call output(a,n,f)
c
      stop
      end
c

