#!/bin/bash
OPTION='-O3 mytimer.c.o pde.f90'
export OMP_NUM_THREADS=1

# compile and run

echo 'Sequntial nonblocking'
ifort $OPTION sor-seq-nobk.f -o sor-seq-nobk >compile.log
sor-seq-nobk

echo 'Sequntial blocking'
ifort $OPTION sor-seq-bk.f -o sor-seq-bk >compile.log
sor-seq-bk

echo 'Sequntial blocking no recovery'
ifort $OPTION sor-seq-bk-norev.f -o sor-seq-bk-norev >compile.log
sor-seq-bk-norev

echo 'Sequntial nonblocking red/black ordering'
ifort $OPTION rbsor-seq-nobk.f -o rbsor-seq-nobk >compile.log
rbsor-seq-nobk

echo 'Sequntial blocking red/black ordering'
ifort $OPTION rbsor-seq-bk.f -o rbsor-seq-bk >compile.log
rbsor-seq-bk



echo 'Sequntial blocking red/black ordering no recovery'
ifort $OPTION rbsor-seq-bk-norev.f -o rbsor-seq-bk-norev >compile.log
rbsor-seq-bk-norev
